/*
  Module BME_280 ESP_32
  part of Arduino Mega Server project
*/

#ifdef FEATURE_BME

#include <BME280I2C.h>

// датчик температуры, давления и влажности
BME280I2C bme;                   // Default : forced mode, standby time = 1000 ms
                              // Oversampling = pressure ×1, temperature ×1, humidity ×1, filter off,

   float temp(NAN), hum(NAN), pres(NAN);



  void Initbme() {
 bme.begin();
    
 
  moduleBME = ENABLE;
  
 // started("BME", true);
  started(F("BME"), true);
}


void bmeWorks() {



     // Отображаем данные с датчика BME-280
      bme.read(pres, temp, hum, true, B101);   // unit: B000 = Pa, B001 = hPa, B010 = Hg, B011 = atm, B100 = bar, B101 = torr, B110 = N/m^2, B111 = psi
      
       temp = (temp - (int)temp) * 100;

        if ((temp > -1) && (temp < 0)) {
          #ifdef FEATURE_MAJOR
            sendRequestMinusM("Temp", "-", (int)temp, abs(temp)); 
          #endif          
        } else {
            #ifdef FEATURE_MAJOR
              sendRequestMinusM("Temp", "", (int)temp, abs(temp)); 
            #endif
          }
 

      Serial.print(temp,1);
      Serial.print(" C , ");
    
      Serial.print(hum,1);
      Serial.print("% ,");

      Serial.print(pres,1);
      Serial.println(" mm.Hg.");  
 
}
#endif
