/*
 * temp.cpp
 * Ol.Moro 2018.02.08
*/
/*
#include "Arduino.h"
#include "DS2482.h"           // I2C to 1-Wire bridge used with ESP WIFI
#include "DS18B20_DS2482.h"
#include "Wire.h"             // I²C
#include "temp.h"

portMUX_TYPE timerMux = portMUX_INITIALIZER_UNLOCKED;

float current_temp0 = 0.0;
float current_temp1 = 0.0;
//float current_temp2 = 0.0;
//float current_temp3 = 0.0;

DS2482 DS2482(0);
DS18B20_DS2482 sensors(&DS2482); 

// Sensors ID's
/*
const byte id0[] = {0x28, 0x22, 0xb3, 0x3b, 0x04, 0x00, 0x00, 0x85};  // sens0 as tempSTR
const byte id1[] = {0x28, 0xfa, 0x77, 0x3b, 0x04, 0x00, 0x00, 0xdd};  // sens1 as tempHOM
const byte id2[] = {0x28, 0xf6, 0xac, 0x3b, 0x04, 0x00, 0x00, 0x8e};  // sens2 as tempWRM
const byte id3[] = {0x28, 0x01, 0x0f, 0x36, 0x04, 0x00, 0x00, 0x99};  // sens3 as tempBTH
*/
/*
const byte id0[] = {0x28, 0x1a, 0x1b, 0x2a, 0x07, 0x00, 0x00, 0x97};  // sens0 as tempSTR
const byte id1[] = {0x28, 0xff, 0xed, 0x1b, 0x03, 0x16, 0x03, 0x92};  // sens1 as tempHOM


void initTemp(void) 
{
  Wire.begin(SDA, SCL, 400000);

  Serial.print("DS2482-100 reset: ");
  DS2482.reset();
  Serial.println("ok");
  
  if (!DS2482.configure(DS2482_CONFIG_APU))
  { 
    Serial.println(F("Active pull-up cofigured.")); 
  } 

  DS2482.wireResetSearch();
  
  // locate devices on the bus
  uint8_t count = DS2482.devicesCount(true);
  Serial.print(F("Found devices: "));   Serial.println(count);

  DS2482.wireResetSearch();
  sensors.setWaitForConversion(false);

}


void workTemp(void)
{
  static int cnt = 5;
  cnt++;
  if ( cnt >= 5 ) { cnt = 0; }
  Serial.print(F(" work Temp2: "));

  switch ( cnt )
  {
  case 0:
    // sends command for all devices on the bus to perform a temperature conversion
    vTaskEnterCritical(&timerMux);
      sensors.requestTemperatures();
    vTaskExitCritical(&timerMux);
    Serial.println(F(" Start conversion for all devices"));
    break;
    
  case 1:
    vTaskEnterCritical(&timerMux);
      current_temp0 = sensors.getTempC((const unsigned char*) &id0);
    vTaskExitCritical(&timerMux);
    Serial.print(F(" Read 1-st device: "));   Serial.println(current_temp0);
    break;
    
  case 2:
    vTaskEnterCritical(&timerMux);
      current_temp1 = sensors.getTempC((const unsigned char*) &id1);
    vTaskExitCritical(&timerMux);
    Serial.print(F(" Read 2-nd device: "));   Serial.println(current_temp1);
    break;
  /*  
  case 3:
    vTaskEnterCritical(&timerMux);
      current_temp2 = sensors.getTempC((const unsigned char*) &id2);
    vTaskExitCritical(&timerMux);
    Serial.print(F(" Read 3-th device: "));   Serial.println(current_temp2);
    break;
    
  case 4:
    vTaskEnterCritical(&timerMux);
      current_temp3 = sensors.getTempC((const unsigned char*) &id3);
    vTaskExitCritical(&timerMux);
    Serial.print(F(" Read 4-th device: "));   Serial.println(current_temp3);
    break;
    */
    /*
  default:

  break;
  }
}
*/
